//=====================================================================
//	      .
//=====================================================================

//---------------------------------------------------------------------
#property copyright 	"Dima S., 2010 ."
#property link      	"dimascub@mail.com"
//---------------------------------------------------------------------

//---------------------------------------------------------------------
#import		"user32.dll"
int		GetSystemMetrics( int _index );
#import
//---------------------------------------------------------------------
#define		SM_CXSCREEN				0
#define		SM_CYSCREEN				1
#define		SM_CXFULLSCREEN		16
#define		SM_CYFULLSCREEN		17
//---------------------------------------------------------------------


//---------------------------------------------------------------------
//	 :
//---------------------------------------------------------------------
#include	<ChartObjects\ChartObjectsTxtControls.mqh>
#include	<Arrays\List.mqh>
//---------------------------------------------------------------------


//=====================================================================
//	  :
//=====================================================================
class TTitleDisplay : public CChartObjectLabel
{
protected:
	long		chart_id;
	int			sub_window;
	long		chart_width;																								//    
	long		chart_height;																								//    
	long		chart_width_step;																						//     
	long		chart_height_step;																					//     
	int			curr_column;
	int			curr_row;
	int			font_size;

protected:
	string	GetUniqName( );																							//   
	
public:
	TTitleDisplay( long _chart_id, int _window, int _col, int _row, string _title, color _color, ENUM_ANCHOR_POINT _anchor = ANCHOR_LEFT, int _fontsize = 10, string _fontname = "Arial", ENUM_BASE_CORNER _corner = CORNER_LEFT_UPPER );
	~TTitleDisplay( );																									// 
	
public:
	void		MoveTo( int _col, int _row );																//	    
};
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//	:
//---------------------------------------------------------------------
TTitleDisplay::TTitleDisplay( long _chart_id, int _window, int _col, int _row, string _title, color _color, ENUM_ANCHOR_POINT _anchor, int _fontsize, string _fontname, ENUM_BASE_CORNER _corner )
:
chart_id( _chart_id ),
sub_window( _window ),
curr_column( _col ),
curr_row( _row ),
font_size( _fontsize )
{
//	    :
	this.chart_width = GetSystemMetrics( SM_CXFULLSCREEN );
	this.chart_height = GetSystemMetrics( SM_CYFULLSCREEN );

//	   :
	this.chart_width_step = this.font_size;
	this.chart_height_step = this.font_size / 2;

//	 :
	this.Create( this.chart_id, this.GetUniqName( ), this.sub_window, ( int )( this.curr_column * this.chart_width_step ), ( int )( this.curr_row * this.chart_height_step ));
	this.Corner( _corner );
	this.Font( _fontname );
	this.FontSize( _fontsize );
	this.Color( _color );
	this.Anchor( _anchor );
	this.Description( _title );
}

//---------------------------------------------------------------------
//	:
//---------------------------------------------------------------------
TTitleDisplay::~TTitleDisplay( )
{
}

//---------------------------------------------------------------------
//	    :
//---------------------------------------------------------------------
void
TTitleDisplay::MoveTo( int _col, int _row )
{
	this.curr_column = _col;
	this.curr_row = _row;

//	    :
	this.X_Distance(( int )( this.curr_column * this.chart_width_step ));
	this.Y_Distance(( int )( this.curr_row * this.chart_height_step ));
}

//---------------------------------------------------------------------
//	  :
//---------------------------------------------------------------------
string
TTitleDisplay::GetUniqName( )
{
	static uint	prev_count = 0;

	uint			count = GetTickCount( );
	while( 1 )
	{
		if( prev_count == UINT_MAX )
		{
			prev_count = 0;
		}
		if( count <= prev_count )
		{
			prev_count++;
			count = prev_count;
		}
		else
		{
			prev_count = count;
		}

//	,       :
		string		name = TimeToString( TimeGMT( ), TIME_DATE | TIME_MINUTES | TIME_SECONDS ) + " " + DoubleToString( count, 0 );
		if( ObjectFind( 0, name ) < 0 )
		{
			return( name );
		}
	}

	return( NULL );
}
//---------------------------------------------------------------------


//=====================================================================
//	   :
//=====================================================================
class TFieldDisplay : public CChartObjectEdit
{
protected:
	long		chart_id;
	int			sub_window;
	long		chart_width;																								//    
	long		chart_height;																								//    
	long		chart_width_step;																						//     
	long		chart_height_step;																					//     
	int			curr_column;
	int			curr_row;
	int			font_size;

private:
	int			type;																												//    ( ,  )

protected:
	string	GetUniqName( );																							//   
	
public:
	TFieldDisplay( long _chart_id, int _window, int _col, int _row, color _color, ENUM_ANCHOR_POINT _anchor = ANCHOR_LEFT, int _fontsize = 10, string _fontname = "Arial", ENUM_BASE_CORNER _corner = CORNER_LEFT_UPPER );
	~TFieldDisplay( );																									// 
	
public:
	void		MoveTo( int _col, int _row );																//	    
};
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//	:
//---------------------------------------------------------------------
TFieldDisplay::TFieldDisplay( long _chart_id, int _window, int _col, int _row, color _color, ENUM_ANCHOR_POINT _anchor, int _fontsize, string _fontname, ENUM_BASE_CORNER _corner )
:
chart_id( _chart_id ),
sub_window( _window ),
curr_column( _col ),
curr_row( _row ),
font_size( _fontsize )
{
//	    :
	this.chart_width = GetSystemMetrics( SM_CXFULLSCREEN );
	this.chart_height = GetSystemMetrics( SM_CYFULLSCREEN );

//	   :
	this.chart_width_step = this.font_size;
	this.chart_height_step = this.font_size / 2;

//	 :
	this.Create( this.chart_id, this.GetUniqName( ), this.sub_window, ( int )( this.curr_column * this.chart_width_step ), ( int )( this.curr_row * this.chart_height_step ));
	this.Corner( _corner );
	this.Font( _fontname );
	this.FontSize( _fontsize );
	this.Color( _color );
	this.Anchor( _anchor );
	this.Description( "" );
}

//---------------------------------------------------------------------
//	:
//---------------------------------------------------------------------
TFieldDisplay::~TFieldDisplay( )
{
}

//---------------------------------------------------------------------
//	    :
//---------------------------------------------------------------------
void
TFieldDisplay::MoveTo( int _col, int _row )
{
	this.curr_column = _col;
	this.curr_row = _row;

//	    :
	this.X_Distance(( int )( this.curr_column * this.chart_width_step ));
	this.Y_Distance(( int )( this.curr_row * this.chart_height_step ));
}

//---------------------------------------------------------------------
//	  :
//---------------------------------------------------------------------
string
TFieldDisplay::GetUniqName( )
{
	static uint	prev_count = 0;

	uint			count = GetTickCount( );
	while( 1 )
	{
		if( prev_count == UINT_MAX )
		{
			prev_count = 0;
		}
		if( count <= prev_count )
		{
			prev_count++;
			count = prev_count;
		}
		else
		{
			prev_count = count;
		}

//	,       :
		string		name = TimeToString( TimeGMT( ), TIME_DATE | TIME_MINUTES | TIME_SECONDS ) + " " + DoubleToString( count, 0 );
		if( ObjectFind( 0, name ) < 0 )
		{
			return( name );
		}
	}

	return( NULL );
}
//---------------------------------------------------------------------


//=====================================================================
//	    :
//=====================================================================
class TableDisplay : public CList
{
protected:
	long		chart_id;
	int			sub_window;

public:
	int			AddTitleObject( int _col, int _row, string _title, color _color, ENUM_ANCHOR_POINT _anchor = ANCHOR_LEFT, int _fontsize = 10, string _fontname = "Arial", ENUM_BASE_CORNER _corner = CORNER_LEFT_UPPER );
	int			AddFieldObject( int _col, int _row, color _color, ENUM_ANCHOR_POINT _anchor = ANCHOR_LEFT, int _fontsize = 10, string _fontname = "Arial", ENUM_BASE_CORNER _corner = CORNER_LEFT_UPPER );

public:
	bool		SetColor( int _index, color _color );
	bool		SetFont( int _index, string _fontname, int _fontsize );
	bool		SetText( int _index, string _text );
	bool		SetAnchor( int _index, ENUM_ANCHOR_POINT _anchor );

public:
	TableDisplay( long _chart_id, int _window );
	~TableDisplay( );
};
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//	:
//---------------------------------------------------------------------
void
TableDisplay::TableDisplay( long _chart_id, int _window )
:
chart_id( _chart_id ),
sub_window( _window )
{
}

//---------------------------------------------------------------------
//	:
//---------------------------------------------------------------------
void
TableDisplay::~TableDisplay( )
{
}

//---------------------------------------------------------------------
//	     ""   :
//---------------------------------------------------------------------
int
TableDisplay::AddTitleObject( int _col, int _row, string _title, color _color, ENUM_ANCHOR_POINT _anchor, int _fontsize, string _fontname, ENUM_BASE_CORNER _corner )
{
	TTitleDisplay*	object = new TTitleDisplay( this.chart_id, this.sub_window, _col, _row, _title, _color, _anchor, _fontsize, _fontname, _corner );
	return( this.Add( object ));
}

//---------------------------------------------------------------------
//	     " "   :
//---------------------------------------------------------------------
int
TableDisplay::AddFieldObject( int _col, int _row, color _color, ENUM_ANCHOR_POINT _anchor, int _fontsize, string _fontname, ENUM_BASE_CORNER _corner )
{
	TFieldDisplay*	object = new TFieldDisplay( this.chart_id, this.sub_window, _col, _row, _color, _anchor, _fontsize, _fontname, _corner );
	object.Description( "" );
	return( this.Add( object ));
}

//---------------------------------------------------------------------
//	   :
//---------------------------------------------------------------------
bool
TableDisplay::SetAnchor( int _index, ENUM_ANCHOR_POINT _anchor )
{
	CChartObjectText*	object = GetNodeAtIndex( _index );
	if( object == NULL )
	{
		return( false );
	}
	return( object.Anchor( _anchor ));
}

//---------------------------------------------------------------------
//	    :
//---------------------------------------------------------------------
bool
TableDisplay::SetColor( int _index, color _color )
{
	CChartObjectText*	object = GetNodeAtIndex( _index );
	if( object == NULL )
	{
		return( false );
	}
	return( object.Color( _color ));
}
//---------------------------------------------------------------------
//	     :
//---------------------------------------------------------------------
bool
TableDisplay::SetFont( int _index, string _fontname, int _fontsize )
{
	CChartObjectText*	object = GetNodeAtIndex( _index );
	if( object == NULL )
	{
		return( false );
	}

	if( object.Font( _fontname ) == false )
	{
		return( false );
	}
	return( object.FontSize( _fontsize ));
}

//---------------------------------------------------------------------
//	     :
//---------------------------------------------------------------------
bool
TableDisplay::SetText( int _index, string _text )
{
	CChartObjectText*	object = GetNodeAtIndex( _index );
	if( object == NULL )
	{
		return( false );
	}
	return( object.Description( _text ));
}
//---------------------------------------------------------------------
